#!/usr/bin/perl
##################################################
# Upload v3.0 for News Pro
# By Russ Mckendrick
# Email: russ@rock-city.co.uk
# Web:   www.rock-city.co.uk
# You may have to change the top line to point
# to your path to perl
##################################################

# See readme.txt for setup instructions.

# SERVER PROBLEMS WORKAROUNDS
# If the script either gets its URL wrong or produces a fatal error
# about not being able to include npconfig.pl, set the following variables.
# While it won't hurt, most users don't have to.

$IIS = 0;
# If you are using Microsoft IIS, set the above to 1. If you are
# using Unix/Apache, set it to 2. Setting it 0 tries to determine
# automatically, and usually works just fine; don't change it unless
# you have problems. If you use IIS yet have 500 error problems, 
# try setting the variable to 2, then try 3.

$abspath = '';
# Set the above to the absolute path to upload.pl's directory, without
# a trailing slash. Example:
# $abspath = '/absolute/path/to/upload';

$scripturl = '';
# Set the above to the URL to upload.pl. Example:
# $scripturl = 'http://www.myserver.com/newspro/upload.pl';
# Once again, you only need to set the above two variables if you're
# having server problems.

#
# END SERVER PROBLEMS WORKAROUNDS
#

if ($abspath) {
	push(@INC, $abspath);
}

# Microsoft servers. Try and be compatible...
if ($IIS != 2) {
	if ($IIS == 0) {
		if ($ENV{'SERVER_SOFTWARE'} =~ m!IIS!) {
			$IIS = 1 
		}
	}
	if (($IIS) && ($0 =~ m!(.*)(\\|\/)!)) {
		chdir($1);
	}
	if ($IIS == 1) {
		print "HTTP/1.0 200 OK\n";
	}
}

require 'nplib.pl';

unless ($scripturl) {
	$scripturl = &GetScriptURL;
}

# Read in the News Pro Settings
open(NPCFG, 'nsettings.cgi');
while (<NPCFG>) {
($varname, $varvalue) = split(/``x/, $_);
$varvalue =~ s/^\s+//;
$varvalue =~ s/\s+$//;
$varvalue =~ s/\n//g;
$NPConfig{$varname} = $varvalue;
}
close(NPCFG);

# Upload The Files
use CGI; 
$onnum = 1;
while ($onnum != 11) {
$req = new CGI;
$file = $req->param("FILE$onnum");
$dir = $req->param("THEDIR");
if ($file ne "") {
my $fileName = $file; 
$fileName =~ s!^.*(\\|\/)!!; 
$newmain = $fileName;
if ($NPConfig{'AllowAll'} ne "yes") {
if (lc(substr($newmain,length($newmain) - 4,4)) ne $NPConfig{'TheExt'}){
$filenotgood = "yes";
}
}
if ($filenotgood ne "yes") {
open (OUTFILE, ">$dir/$fileName");
binmode(OUTFILE);
print "$dir/$fileName<br>";
while (my $bytesread = read($file, my $buffer, 1024)) {
print OUTFILE $buffer;
}
close (OUTFILE); 
}
}
$onnum++;
}

print "Content-type: text/html\n";
print "Location:$ENV{HTTP_REFERER}\n\n";
